import { PluginConfig } from "./interfaces/plugin-config.interface";
import { Rule, RuleWithAppliedOptions } from "./interfaces/rule.interface";
import { SupportLatestOptions } from "./rules/support-latest";
import { SupportPreReleaseOptions } from "./rules/support-prerelease-if-not-released";
export default class ConfigurationLoader {
    private readonly deprecateAll;
    private readonly supportLatest;
    private readonly supportPreReleaseIfNotReleased;
    constructor({ deprecateAll, supportLatest, supportPreReleaseIfNotReleased, }: {
        deprecateAll: Rule<void>;
        supportLatest: Rule<SupportLatestOptions>;
        supportPreReleaseIfNotReleased: Rule<SupportPreReleaseOptions>;
    });
    generateRules(pluginConfig: PluginConfig): RuleWithAppliedOptions[];
    private generateRule;
    private generateDefaultRules;
}
