import { SemVer } from "semver";
export declare enum Action {
    deprecate = "deprecate",
    support = "support",
    continue = "continue"
}
export declare type RuleResult = {
    action: Action.continue;
} | {
    action: Action.support;
} | {
    action: Action.deprecate;
    reason?: string;
};
export declare type Rule<TOptions> = (ruleOptions: TOptions | undefined, version: SemVer, allVersionsSortedLatestFirst: SemVer[]) => RuleResult;
export declare type RuleWithAppliedOptions = (version: SemVer, allVersionsSortedLatestFirst: SemVer[]) => RuleResult;
