"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var list_active_versions_1 = __importDefault(require("./list-active-versions"));
describe("listActiveVersions", function () {
    it("should return versions that are not deprecated", function () {
        var packageInfo = {
            name: "foo",
            versions: {
                "0.0.1": {
                    name: "foo",
                    version: "0.0.1",
                },
                "0.0.2": {
                    name: "foo",
                    version: "0.0.2",
                },
            },
        };
        var result = list_active_versions_1.default(packageInfo);
        expect(result).toEqual(["0.0.1", "0.0.2"]);
    });
    it("should not return deprecated versions", function () {
        var packageInfo = {
            name: "foo",
            versions: {
                "0.0.1": {
                    name: "foo",
                    version: "0.0.1",
                    deprecated: "",
                },
                "0.0.2": {
                    name: "foo",
                    version: "0.0.2",
                    deprecated: "In favor of 0.0.3",
                },
            },
        };
        var result = list_active_versions_1.default(packageInfo);
        expect(result).toEqual([]);
    });
});
