"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var strong_mock_1 = require("strong-mock");
var npm_api_1 = require("./npm-api");
describe("NpmApi", function () {
    function setup() {
        var fetch = strong_mock_1.mock();
        var npmApi = new npm_api_1.NpmApi(strong_mock_1.instance(fetch));
        return {
            fetch: fetch,
            npmApi: npmApi,
        };
    }
    describe("getInfo", function () {
        it("should get info from the npm api and return it", function () { return __awaiter(void 0, void 0, void 0, function () {
            var _a, npmApi, fetch, packageName, npmConfig, logger, packageInfo, result;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = setup(), npmApi = _a.npmApi, fetch = _a.fetch;
                        packageName = "packageName";
                        npmConfig = {
                            registry: "registry",
                        };
                        logger = strong_mock_1.mock();
                        packageInfo = {
                            name: "name",
                            versions: {
                                "1.0.0": {
                                    version: "1.0.0",
                                    name: "name",
                                },
                            },
                        };
                        strong_mock_1.when(fetch("" + npmConfig.registry + encodeURIComponent(packageName))).thenResolve({
                            status: 200,
                            json: function () { return Promise.resolve(packageInfo); },
                        });
                        return [4 /*yield*/, npmApi.getInfo(packageName, npmConfig, {
                                logger: strong_mock_1.instance(logger),
                            })];
                    case 1:
                        result = _b.sent();
                        expect(result).toEqual(packageInfo);
                        strong_mock_1.verifyAll();
                        return [2 /*return*/];
                }
            });
        }); });
        it("should return undefined if the api returns a 404", function () { return __awaiter(void 0, void 0, void 0, function () {
            var _a, npmApi, fetch, packageName, npmConfig, logger, result;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = setup(), npmApi = _a.npmApi, fetch = _a.fetch;
                        packageName = "packageName";
                        npmConfig = {
                            registry: "registry",
                        };
                        logger = strong_mock_1.mock();
                        strong_mock_1.when(fetch("" + npmConfig.registry + encodeURIComponent(packageName))).thenResolve({
                            status: 404,
                        });
                        strong_mock_1.when(logger.log("Package not found on the registry")).thenReturn(undefined);
                        return [4 /*yield*/, npmApi.getInfo(packageName, npmConfig, {
                                logger: strong_mock_1.instance(logger),
                            })];
                    case 1:
                        result = _b.sent();
                        expect(result).toBeUndefined();
                        strong_mock_1.verifyAll();
                        return [2 /*return*/];
                }
            });
        }); });
        it("should throw an error if the api returns a 500", function () { return __awaiter(void 0, void 0, void 0, function () {
            var _a, npmApi, fetch, packageName, npmConfig, logger;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = setup(), npmApi = _a.npmApi, fetch = _a.fetch;
                        packageName = "packageName";
                        npmConfig = {
                            registry: "registry",
                        };
                        logger = strong_mock_1.mock();
                        strong_mock_1.when(fetch("" + npmConfig.registry + encodeURIComponent(packageName))).thenResolve({
                            status: 500,
                            text: function () { return Promise.resolve("Error"); },
                        });
                        strong_mock_1.when(logger.error("Unable to retrieve info from the registry", new Error("Error received from the registry 500 Error"))).thenReturn(undefined);
                        return [4 /*yield*/, expect(npmApi.getInfo(packageName, npmConfig, {
                                logger: strong_mock_1.instance(logger),
                            })).rejects.toThrowError("Error received from the registry 500 Error")];
                    case 1:
                        _b.sent();
                        strong_mock_1.verifyAll();
                        return [2 /*return*/];
                }
            });
        }); });
    });
});
