"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Npm = void 0;
var npm_error_1 = require("./npm-error");
function tryParse(content) {
    try {
        return JSON.parse(content);
    }
    catch (e) {
        return null;
    }
}
function removeNpmText(content) {
    return content.replace(/^npm ERR!.*$/gm, "");
}
var Npm = /** @class */ (function () {
    function Npm(execa) {
        this.execa = execa;
    }
    Npm.prototype.authenticate = function (_a, context) {
        var registry = _a.registry;
        return __awaiter(this, void 0, void 0, function () {
            var registryUrl;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        registryUrl = registry.replace(/^https?:/, "").replace(/\/$/, "");
                        return [4 /*yield*/, this.runJsonNpm(["config", "set", registryUrl + "/:_authToken", "${NPM_TOKEN}"], context)];
                    case 1:
                        _b.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Npm.prototype.whoAmI = function (context) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.runJsonNpm(["whoami"], context)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Npm.prototype.deprecate = function (_a, context) {
        var name = _a.name, version = _a.version, reason = _a.reason;
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.runJsonNpm(["deprecate", name + "@" + version, "" + reason], context)];
                    case 1:
                        _b.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Npm.prototype.getBasicInfo = function (context) {
        return __awaiter(this, void 0, void 0, function () {
            var result, parsedResponse;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.runJsonNpm(["view"], context)];
                    case 1:
                        result = _a.sent();
                        parsedResponse = JSON.parse(result.stdout);
                        return [2 /*return*/, parsedResponse];
                }
            });
        });
    };
    Npm.prototype.getConfig = function (context) {
        return __awaiter(this, void 0, void 0, function () {
            var result, parsedResponse, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.runJsonNpm(["config", "list"], context)];
                    case 1:
                        result = _a.sent();
                        parsedResponse = JSON.parse(result.stdout);
                        context.logger.log("Registry used:", parsedResponse.registry);
                        return [2 /*return*/, parsedResponse];
                    case 2:
                        e_1 = _a.sent();
                        console.error(e_1);
                        context.logger.error("Unable to retrieve the config for npm");
                        throw e_1;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    Npm.prototype.runJsonNpm = function (args, _a) {
        var cwd = _a.cwd, env = _a.env;
        return __awaiter(this, void 0, void 0, function () {
            var e_2, parsed, parsed;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _b.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.execa("npm", __spreadArrays(args, ["--json"]), { cwd: cwd, env: env })];
                    case 1: return [2 /*return*/, _b.sent()];
                    case 2:
                        e_2 = _b.sent();
                        if (e_2.stdout) {
                            parsed = tryParse(e_2.stdout);
                            if (parsed) {
                                throw new npm_error_1.NpmError(parsed.error.code, parsed.error.summary, e_2);
                            }
                        }
                        if (e_2.stderr) {
                            parsed = tryParse(removeNpmText(e_2.stderr));
                            if (parsed) {
                                throw new npm_error_1.NpmError(parsed.error.code, parsed.error.summary, e_2);
                            }
                        }
                        throw e_2;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    return Npm;
}());
exports.Npm = Npm;
