import { Config, Context } from "semantic-release";
import { PluginConfig } from "./interfaces/plugin-config.interface";
import { PackageInfoRetriever } from "./package-info-retriever";
import { RuleApplier } from "./rule-applier";
import { Deprecier } from "./deprecier";
import { Authentifier } from "./authentifier";
import ConfigurationLoader from "./configuration-loader";
import { ListActiveVersions } from "./list-active-versions";
import { DeprecierState } from "./deprecier-state";
import { Npm } from "./npm";
export declare class OldVersionDeprecier {
    private readonly packageInfoRetriever;
    private readonly ruleApplier;
    private readonly deprecier;
    private readonly authentifier;
    private readonly configurationLoader;
    private readonly listActiveVersions;
    private readonly npm;
    private readonly deprecierState;
    constructor(packageInfoRetriever: PackageInfoRetriever, ruleApplier: RuleApplier, deprecier: Deprecier, authentifier: Authentifier, configurationLoader: ConfigurationLoader, listActiveVersions: ListActiveVersions, npm: Npm, deprecierState: DeprecierState);
    verifyConditions(pluginConfig: PluginConfig): Promise<void>;
    prepare(pluginConfig: PluginConfig, context: Context & Config): Promise<void>;
    publish(pluginConfig: PluginConfig, context: Context & Config): Promise<void>;
    private deprecate;
}
