"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OldVersionDeprecier = void 0;
var rule_interface_1 = require("./interfaces/rule.interface");
var semver_1 = require("semver");
var OldVersionDeprecier = /** @class */ (function () {
    function OldVersionDeprecier(packageInfoRetriever, ruleApplier, deprecier, authentifier, configurationLoader, listActiveVersions, npm, deprecierState) {
        this.packageInfoRetriever = packageInfoRetriever;
        this.ruleApplier = ruleApplier;
        this.deprecier = deprecier;
        this.authentifier = authentifier;
        this.configurationLoader = configurationLoader;
        this.listActiveVersions = listActiveVersions;
        this.npm = npm;
        this.deprecierState = deprecierState;
    }
    OldVersionDeprecier.prototype.verifyConditions = function (pluginConfig) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.deprecierState.rules = this.configurationLoader.generateRules(pluginConfig);
                return [2 /*return*/];
            });
        });
    };
    OldVersionDeprecier.prototype.prepare = function (pluginConfig, context) {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.deprecierState;
                        return [4 /*yield*/, this.npm.getConfig(context)];
                    case 1:
                        _a.npmConfig = _b.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    OldVersionDeprecier.prototype.publish = function (pluginConfig, context) {
        return __awaiter(this, void 0, void 0, function () {
            var logger, packageInfo, activeVersions, parsedVersions, actionsOnVersions;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        logger = context.logger;
                        if (!this.deprecierState.npmConfig) {
                            throw new Error("Unable to deprecate version as the configuration of NPM could not be retrieved");
                        }
                        return [4 /*yield*/, this.packageInfoRetriever.getInfo(this.deprecierState.npmConfig, context)];
                    case 1:
                        packageInfo = _a.sent();
                        if (!packageInfo) {
                            logger.log("This project does not seem to be a npm package");
                            return [2 /*return*/];
                        }
                        activeVersions = this.listActiveVersions(packageInfo);
                        logger.log("Active versions: " + activeVersions.join(", "));
                        parsedVersions = activeVersions.map(function (v) { return new semver_1.SemVer(v); });
                        actionsOnVersions = this.ruleApplier.applyRules(parsedVersions, this.deprecierState.rules);
                        return [4 /*yield*/, this.deprecate(actionsOnVersions, packageInfo, context)];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    OldVersionDeprecier.prototype.deprecate = function (actionsOnVersions, packageInfo, context) {
        return __awaiter(this, void 0, void 0, function () {
            var depreciations, _i, depreciations_1, depreciation;
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        depreciations = actionsOnVersions
                            .filter(function (actionOnVersion) { return actionOnVersion.action === rule_interface_1.Action.deprecate; })
                            .map(function (actionsOnVersion) { return actionsOnVersion; });
                        if (!(depreciations === null || depreciations === void 0 ? void 0 : depreciations.length)) return [3 /*break*/, 7];
                        (_a = context.logger).log.apply(_a, __spreadArrays(["Versions to deprecate"], depreciations.map(function (v) { return v.version.format(); })));
                        return [4 /*yield*/, this.authentifier.authenticate(this.deprecierState.npmConfig, context)];
                    case 1:
                        _b.sent();
                        return [4 /*yield*/, this.authentifier.checkAuthentication(context)];
                    case 2:
                        _b.sent();
                        _i = 0, depreciations_1 = depreciations;
                        _b.label = 3;
                    case 3:
                        if (!(_i < depreciations_1.length)) return [3 /*break*/, 6];
                        depreciation = depreciations_1[_i];
                        return [4 /*yield*/, this.deprecier.deprecate(packageInfo, depreciation, context)];
                    case 4:
                        _b.sent();
                        _b.label = 5;
                    case 5:
                        _i++;
                        return [3 /*break*/, 3];
                    case 6: return [3 /*break*/, 8];
                    case 7:
                        context.logger.log("No version to deprecate");
                        _b.label = 8;
                    case 8: return [2 /*return*/];
                }
            });
        });
    };
    return OldVersionDeprecier;
}());
exports.OldVersionDeprecier = OldVersionDeprecier;
